#include "usart.h"
#define LED 13
#define BUTTON 3
int buttonState = 0; 
int mode = 0; // 0 for text, 1 for Morse
int s = 0; // was the last letter s?

//For letters
char* letters[] = {
  ".-", "-...", "-.-.", "-..", ".", "..-.", "--.", "....", "..",    // A-I
  ".---", "-.-", ".-..", "--", "-.", "---", ".--.", "--.-", ".-.",  // J-R
  "...", "-", "..-", "...-", ".--", "-..-", "-.--", "--.."          // S-Z
};

//For Numbers
char* numbers[] = {
  "-----", ".----", "..---", "...--", "....-", ".....",
  "-....", "--...", "---..", "----."
};
int dotDelay = 200;

void setup() {
  // put your setup code here, to run once:

  // pinMode(LED, OUTPUT);
  DDRB |= (1<<PB5);
  pinMode(BUTTON, INPUT);
  Serial.begin(9600);
  USART0_init();

}

void loop() {
  // put your main code here, to run repeatedly:

if(mode == 0){
   char ch;

    if (Serial.available()) {
      ch = Serial.read();  
      if (ch >= 'a' && ch <= 'z') {
        flashSequence(letters[ch - 'a']);
      } else if (ch >= 'A' && ch <= 'Z') {
        flashSequence(letters[ch - 'A']);
      } else if (ch >= '0' && ch <= '9') {
        flashSequence(numbers[ch - '0']);
      } else if (ch == ' ') {
        delay(dotDelay * 4);
      }
      Serial.print("S este");
      Serial.print(s);
      if(s == 1){
        if(ch == 'w'){
          mode = 1;
        }
        s = 0;
      }
      if(ch == 's')
        s = 1;
      
    
  }
  
}
else {
  while(digitalRead(BUTTON) == LOW);

    String morseCode = interpretMorseCode();
    String message = decodeMorseCode(morseCode);
    Serial.println(message);
  
}

}

String interpretMorseCode() {
  String morseCode;
  unsigned long startTime = millis();
  
  while (digitalRead(BUTTON)) {
    // Detect the duration of the button press
    unsigned long duration = millis() - startTime;

    if (duration >= dotDelay * 3) {
      morseCode += "-";
    } else if (duration >= dotDelay) {
      morseCode += ".";
    }

    delay(dotDelay);
  }

  return morseCode;
}

// Decode Morse code into ASCII characters
String decodeMorseCode(const String& morseCode) {
  String decodedMessage;
  int morseCodeLength = morseCode.length();
  
  for (int i = 0; i < morseCodeLength; i++) {
    char c = morseCode.charAt(i);
    
    if (c == '.') {
      decodedMessage += ".";
    } else if (c == '-') {
      decodedMessage += "-";
    } else if (c == ' ') {
      if (decodedMessage.length() > 0) {
        decodedMessage += getCharacterFromMorse(decodedMessage);
      }
      decodedMessage += " ";
    }
  }

  if (decodedMessage.length() > 0) {
    decodedMessage += getCharacterFromMorse(decodedMessage);
  }

  return decodedMessage;
}

// Get ASCII character from Morse code
char getCharacterFromMorse(const String& morse) {
  int tableSize = sizeof(letters) / sizeof(letters[0]);
  
  for (int i = 0; i < tableSize; i++) {
    if (morse.equals(letters[i])) {
      return 'A' + i;
    }
  }

  return '?'; 
}


void flashSequence(char* sequence) {
  int i = 0;
  while (sequence[i] != NULL) {
    flashDotOrDash(sequence[i]);
    i++;
  }
  delay(dotDelay * 3);
}


void flashDotOrDash(char dotOrDash) {
  // digitalWrite(LED, HIGH);
  PORTB |= (1<<PB5);
  if (dotOrDash == '.') {
    delay(dotDelay);
  } else 
  {
    delay(dotDelay * 3);
  }
  // digitalWrite(LED, LOW);
  PORTB &= ~(1<<PB5);
  delay(dotDelay);
}